# Breve
### a url shortener

Breve is a web application that provides a simple interface to
shortening long urls creating links smaller and easier to remember.

You can find a running instance on [brve.bit](https://brve.bit)

It creates links in the form of "/emeaoinqua": easier to remember than
alphanumeric strings like "/1Cqw8lHw" used by several services.

It was inspired by [hastebin](http://hastebin.com).

## Installing

Install the app with cabal-install. Run

    $ cabal install breve

and start it with
	
    $ breve

The app will start serving on `https://localhost:3000`, listening on every active interface.

## Configure

You can change the options by editing the config file.
When you start the app an empty one will be created in:
`$XDG_CONFIG_HOME/breve`, `~/.config/breve` if unset,
or you can pass a path as the first argument of breve.

The default values are:

```ini
hostname = "localhost"
port     = 3000
baseurl  = "https://localhost:3000/"
urltable = "$XDG_CONFIG_HOME/breve"
tls {
  cert  = "/usr/share/tls/breve.crt"
  key   = "/usr/share/tls/breve.key"
  chain = []
}
```

`urltable` is the location of breve url hashtable

`chain` is a list of chain certificate files

## License

Copyright (C) 2019 Michele Guerini Rocco

This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see http://www.gnu.org/licenses/.
